from pasteob.base import Request

__all__ = ['ReqAddon']


class ReqAddon(object):
    class __metaclass__(type):
        def __call__(cls, env, *args):
            if type(env) is not dict:
                # env is a Request object
                env = env.environ
            key = (cls, args)
            try:
                addons = env['pasteob.reqaddons']
                if addons['id(env)'] != id(env):
                    # this is a copied environ, we want a new addons dict
                    raise KeyError
            except KeyError:
                addons = env['pasteob.reqaddons'] = {'id(env)': id(env)}
            else:
                if key in addons:
                    return addons[key]
            r = addons[key] = type.__call__(cls, Request(env), *args)
            return r

    def __init__(self, req):
        pass
